#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int main(int argc, char**argv) {
  struct stat info;
  int czas=-1;
  time_t czasmod;
  char cmd[400];
  struct tm*structcz;

  if (argc!=3) {
    fprintf(stderr, "Zla liczba parametrow\n");
    return EXIT_FAILURE;
  }

  if (stat(argv[1], &info) || !(info.st_mode&S_IRUSR)) {
    fprintf(stderr, "Nie mozna otworzyc pliku\n");
    return EXIT_FAILURE;
  }

  czasmod = info.st_mtime;

  sscanf(argv[2], "%d", &czas);
  if (czas<0) {
    fprintf(stderr, "Bledny odstep czasowy\n");
    return EXIT_FAILURE;
  }

  for(;;) {
    if (!stat(argv[1], &info)) {
      sleep(czas);
      if (czasmod!=info.st_mtime) {
	czasmod = info.st_mtime;
	structcz=localtime(&czasmod);
	sprintf(cmd, "cp %s %s.%02d-%02d-%04d.%02d:%02d:%02d",
		argv[1],
		argv[1],
		structcz->tm_mday,
		structcz->tm_mon,
		structcz->tm_year+1900,
		structcz->tm_hour,
		structcz->tm_min,
		structcz->tm_sec);
	system(cmd);
      }
    } else {
      fprintf(stderr, "Wystapil blad\n");
      return EXIT_FAILURE;
    }
  }
}
