#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <dirent.h>

int main() {
  int fifodesc;
  char buf[10];
  int io[2];
  int i;

  for (i=0; i<10; i++)
    buf[i]=0;

  pipe(io);
  mkfifo("tmpfifo", S_IRWXU);

  if (!fork()) {
    system("echo $(( `ps x | wc -l` - 1 )) > tmpfifo");
    exit(EXIT_SUCCESS);
  }

  if (!fork()) {
    DIR*dir = opendir(".");
    int cnt = -2;

    while(readdir(dir))
      cnt++;

    closedir(dir);

    write(io[1], &cnt, sizeof(int));

    exit(EXIT_SUCCESS);
  }

  fifodesc = open("tmpfifo", O_RDONLY);
  read(fifodesc, buf, 10);
  printf("Liczba procesw: %s", buf);
  close(fifodesc);
  remove("tmpfifo");

  read(io[0], &i, sizeof(int));
  printf("Liczba plikw: %d\n", i);
  
  return EXIT_SUCCESS;
}
