#include <signal.h>
#include <stdlib.h>
#include <stdio.h>

int odebrano = 0;

void obsluz() {
  odebrano = 1;
}

int main(int argc, char** argv) {
  int ilosc=0, pid, i;
  
  if (argc!=2) {
    fprintf(stderr, "Bledna ilosc parametrow\n");
    return EXIT_FAILURE;
  }

  sscanf(argv[1], "%d", &ilosc);
  if (ilosc<1) {
    fprintf(stderr, "Bledna ilosc powtorzen\n");
    return EXIT_FAILURE;
  }

  signal(SIGUSR1, obsluz);

  if (!(pid=fork())) {
    execl("./potomek");
  }

  kill(pid, SIGUSR1);

  for (i=1; i<ilosc;) {
    if (odebrano) {
      odebrano = 0;
      kill(pid, SIGUSR1);
      i++;
    }
  }

  while(!odebrano);
  kill(pid, SIGUSR2);

  return EXIT_SUCCESS;
}
